Subject: Re: bug#8297: Request: Better Emacs self-documentation for customization

From: Florian Beck <[email-masked]>
Date: Wed, 23 Mar 2011 09:59:37 +0100

On 03/21/2011 11:00 PM, Stefan Monnier wrote:

> Note that for your case, another option is to use a defadvice, and
> indeed defadvice should also add a hyperlink to the advice.

Right. So that one is not so urgent. It is only that I already have 
quite some redefined functions (from the emacs source or from 
third-party packages) and finding the original definition can be 
surprisingly difficult.

>
>>   - 'describe-variable', on the other hand, remembers the original
>> definition, but doesn't remember the place where I changed the value.
>
> That might turn out to be more difficult to track, but at least for some
> simple cases (e.g. when the vlue is changed via `custom' functions rather
> than via `setq') that should definitely be doable.  If the var was set
> via `setq' it's more difficult since `setq' is a very low-level
> primitive that needs to run fast.

Understood. Again, unfortunatly `setq' is what I have. Perhaps an 
old-fashioned but definitly valid way of customizing.

> But maybe we could somehow handle
> `setq' outside of functions in a special way (these shouldn't impact
> performance since they can't be in loops).

That would be great indeed.

>
>>   - `describe-key' only provides a link to the function, not to the place the
>> key was defined.
>
> That's also more difficult because OT1H `define-key' does not get much
> information (it can check load-file-name, but it doesn't know the line
> number, nor the name of the map it receives and neither does it know
> reliably what the key description looks like in the source file, so it's
> hard to do a regexp-search), and OTOH there's no place currently to
> store that information, tho I guess we could keep it in some side
> hash-table.

This one, on the other hand, is a major annoyance. Say, I use 
`global-set-key' to customize a key binding. I continue working with my 
emacs session, maybe for day. But the next time I start emacs, the 
binding is overwritten, because I defined the same key in some other file.

>
>> Obviously, this is not easy, because evaluations don't necessarily
>> have a fixed place and key bindings can be defined in many ways. Regardless,
>> I think this is something on which Emacs could improve.
>
> Agreed.  It's not high on my todo list, but I'll be happy to take
> patches for those.  For defadvice it should be pretty easy, and for
> function re-definitions it shouldn't be too hard either.
>
>
>          Stefan
>
>
>
>